"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
require("@tensorflow/tfjs-node");
var tf = require("@tensorflow/tfjs");
var jasmine_util_1 = require("@tensorflow/tfjs-core/dist/jasmine_util");
var fs_1 = require("fs");
var path_1 = require("path");
var rimraf = require("rimraf");
var tempfile = require("tempfile");
var browser_fft_recognizer_1 = require("./browser_fft_recognizer");
var BrowserFftUtils = require("./browser_fft_utils");
var browser_test_utils_1 = require("./browser_test_utils");
var index_1 = require("./index");
describe('getMajorAndMinorVersion', function () {
    it('Correct results', function () {
        expect(browser_fft_recognizer_1.getMajorAndMinorVersion('0.1.3')).toEqual('0.1');
        expect(browser_fft_recognizer_1.getMajorAndMinorVersion('1.0.9')).toEqual('1.0');
        expect(browser_fft_recognizer_1.getMajorAndMinorVersion('2.0.0rc0')).toEqual('2.0');
        expect(browser_fft_recognizer_1.getMajorAndMinorVersion('2.0.9999999')).toEqual('2.0');
        expect(browser_fft_recognizer_1.getMajorAndMinorVersion('3.0')).toEqual('3.0');
    });
});
jasmine_util_1.describeWithFlags('Browser FFT recognizer', tf.test_util.NODE_ENVS, function () {
    var fakeWords = [
        '_background_noise_', 'down', 'eight', 'five', 'four', 'go', 'left', 'nine',
        'one', 'right', 'seven', 'six', 'stop', 'three', 'two', 'up', 'zero'
    ];
    var fakeWordsNoiseAndUnknownOnly = ['_background_noise_', '_unknown_'];
    var fakeNumFrames = 42;
    var fakeColumnTruncateLength = 232;
    function setUpFakes(model, backgroundAndNoiseOnly) {
        var _this = this;
        if (backgroundAndNoiseOnly === void 0) { backgroundAndNoiseOnly = false; }
        var words = backgroundAndNoiseOnly ? fakeWordsNoiseAndUnknownOnly : fakeWords;
        var numWords = words.length;
        spyOn(tf, 'loadModel').and.callFake(function (url) {
            if (model == null) {
                model = tf.sequential();
                model.add(tf.layers.flatten({ inputShape: [fakeNumFrames, fakeColumnTruncateLength, 1] }));
                model.add(tf.layers.dense({ units: 4, activation: 'relu' }));
                model.add(tf.layers.dense({ units: numWords, useBias: false, activation: 'softmax' }));
            }
            return model;
        });
        spyOn(BrowserFftUtils, 'loadMetadataJson')
            .and.callFake(function (url) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, { words: words }];
            });
        }); });
        spyOn(BrowserFftUtils, 'getAudioContextConstructor')
            .and.callFake(function () { return browser_test_utils_1.FakeAudioContext.createInstance; });
        spyOn(BrowserFftUtils, 'getAudioMediaStream')
            .and.callFake(function () { return new browser_test_utils_1.FakeAudioMediaStream(); });
    }
    it('Constructor works', function () {
        var recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
        expect(recognizer.isListening()).toEqual(false);
        expect(recognizer.params().sampleRateHz).toEqual(44100);
        expect(recognizer.params().fftSize).toEqual(1024);
    });
    it('ensureModelLoaded succeeds', function () { return __awaiter(_this, void 0, void 0, function () {
        var recognizer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, recognizer.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    expect(recognizer.wordLabels()).toEqual(fakeWords);
                    expect(recognizer.model instanceof tf.Model).toEqual(true);
                    expect(recognizer.modelInputShape()).toEqual([
                        null, fakeNumFrames, fakeColumnTruncateLength, 1
                    ]);
                    return [2];
            }
        });
    }); });
    it('ensureModelLoaded fails: words - model output mismatch', function () { return __awaiter(_this, void 0, void 0, function () {
        var fakeModel, recognizer, caughtError, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fakeModel = tf.sequential();
                    fakeModel.add(tf.layers.flatten({ inputShape: [fakeNumFrames, fakeColumnTruncateLength, 1] }));
                    fakeModel.add(tf.layers.dense({ units: 12, activation: 'softmax' }));
                    setUpFakes(fakeModel);
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4, recognizer.ensureModelLoaded()];
                case 2:
                    _a.sent();
                    return [3, 4];
                case 3:
                    err_1 = _a.sent();
                    caughtError = err_1;
                    return [3, 4];
                case 4:
                    expect(caughtError.message)
                        .toMatch(/Mismatch between .* dimension.*12.*17/);
                    return [2];
            }
        });
    }); });
    function createFakeModelArtifact(tmpDir) {
        return __awaiter(this, void 0, void 0, function () {
            var model;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        model = tf.sequential();
                        model.add(tf.layers.reshape({ targetShape: [43 * 232], inputShape: [43, 232, 1] }));
                        model.add(tf.layers.dense({ units: 4, activation: 'softmax' }));
                        return [4, model.save("file://" + tmpDir)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    }
    function createFakeMetadataFile(tmpDir) {
        var metadata = {
            words: ['_background_noise_', '_unknown_', 'foo', 'bar'],
            frameSize: 232
        };
        var metadataPath = path_1.join(tmpDir, 'metadata.json');
        fs_1.writeFileSync(metadataPath, JSON.stringify(metadata));
    }
    it('Constructing recognize using custom URLs', function () { return __awaiter(_this, void 0, void 0, function () {
        var tmpDir, modelPath, metadataPath, modelURL, metadataURL, recognizer, recogResult;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    tmpDir = tempfile();
                    return [4, createFakeModelArtifact(tmpDir)];
                case 1:
                    _a.sent();
                    createFakeMetadataFile(tmpDir);
                    modelPath = path_1.join(tmpDir, 'model.json');
                    metadataPath = path_1.join(tmpDir, 'metadata.json');
                    modelURL = "file://" + modelPath;
                    metadataURL = "file://" + metadataPath;
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer(null, modelURL, metadataURL);
                    return [4, recognizer.ensureModelLoaded()];
                case 2:
                    _a.sent();
                    expect(recognizer.wordLabels()).toEqual([
                        '_background_noise_', '_unknown_', 'foo', 'bar'
                    ]);
                    return [4, recognizer.recognize(tf.zeros([2, 43, 232, 1]))];
                case 3:
                    recogResult = _a.sent();
                    expect(recogResult.scores.length).toEqual(2);
                    expect(recogResult.scores[0].length).toEqual(4);
                    expect(recogResult.scores[1].length).toEqual(4);
                    rimraf(tmpDir, function () { });
                    return [2];
            }
        });
    }); });
    it('Creating recognizer using custom URLs', function () { return __awaiter(_this, void 0, void 0, function () {
        var tmpDir, modelPath, metadataPath, modelURL, metadataURL, recognizer, recogResult;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    tmpDir = tempfile();
                    return [4, createFakeModelArtifact(tmpDir)];
                case 1:
                    _a.sent();
                    createFakeMetadataFile(tmpDir);
                    modelPath = path_1.join(tmpDir, 'model.json');
                    metadataPath = path_1.join(tmpDir, 'metadata.json');
                    modelURL = "file://" + modelPath;
                    metadataURL = "file://" + metadataPath;
                    recognizer = index_1.create('BROWSER_FFT', null, modelURL, metadataURL);
                    return [4, recognizer.ensureModelLoaded()];
                case 2:
                    _a.sent();
                    expect(recognizer.wordLabels()).toEqual([
                        '_background_noise_', '_unknown_', 'foo', 'bar'
                    ]);
                    return [4, recognizer.recognize(tf.zeros([2, 43, 232, 1]))];
                case 3:
                    recogResult = _a.sent();
                    expect(recogResult.scores.length).toEqual(2);
                    expect(recogResult.scores[0].length).toEqual(4);
                    expect(recogResult.scores[1].length).toEqual(4);
                    rimraf(tmpDir, function () { });
                    return [2];
            }
        });
    }); });
    it('Providing both vocabulary and modelURL leads to Error', function () {
        expect(function () { return new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer('vocab_1', 'http://localhost/model.json', 'http://localhost/metadata.json'); })
            .toThrowError(/vocabulary name must be null or undefined .* modelURL/);
    });
    it('Providing modelURL without metadataURL leads to Error', function () {
        expect(function () { return new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer(null, 'http://localhost/model.json'); })
            .toThrowError(/modelURL and metadataURL must be both provided/);
    });
    it('Offline recognize succeeds with single tf.Tensor', function () { return __awaiter(_this, void 0, void 0, function () {
        var spectrogram, recognizer, output;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    spectrogram = tf.zeros([1, fakeNumFrames, fakeColumnTruncateLength, 1]);
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, recognizer.recognize(spectrogram)];
                case 1:
                    output = _a.sent();
                    expect(output.scores instanceof Float32Array).toEqual(true);
                    expect(output.scores.length).toEqual(17);
                    return [2];
            }
        });
    }); });
    it('Offline recognize succeeds with batched tf.Tensor', function () { return __awaiter(_this, void 0, void 0, function () {
        var spectrogram, recognizer, output, i;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    spectrogram = tf.zeros([3, fakeNumFrames, fakeColumnTruncateLength, 1]);
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, recognizer.recognize(spectrogram)];
                case 1:
                    output = _a.sent();
                    expect(Array.isArray(output.scores)).toEqual(true);
                    expect(output.scores.length).toEqual(3);
                    for (i = 0; i < 3; ++i) {
                        expect(output.scores[i].length).toEqual(17);
                    }
                    return [2];
            }
        });
    }); });
    it('Offline recognize call: includeEmbedding', function () { return __awaiter(_this, void 0, void 0, function () {
        var numExamples, spectrogram, recognizer, output, i;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    numExamples = 3;
                    spectrogram = tf.zeros([numExamples, fakeNumFrames, fakeColumnTruncateLength, 1]);
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, recognizer.recognize(spectrogram, { includeEmbedding: true })];
                case 1:
                    output = _a.sent();
                    expect(Array.isArray(output.scores)).toEqual(true);
                    expect(output.scores.length).toEqual(3);
                    for (i = 0; i < 3; ++i) {
                        expect(output.scores[i].length).toEqual(17);
                    }
                    expect(output.embedding.rank).toEqual(2);
                    expect(output.embedding.shape[0]).toEqual(numExamples);
                    return [2];
            }
        });
    }); });
    it('Offline recognize fails due to incorrect shape', function () { return __awaiter(_this, void 0, void 0, function () {
        var spectrogram, recognizer, caughtError, err_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    spectrogram = tf.zeros([1, fakeNumFrames, fakeColumnTruncateLength, 2]);
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4, recognizer.recognize(spectrogram)];
                case 2:
                    _a.sent();
                    return [3, 4];
                case 3:
                    err_2 = _a.sent();
                    caughtError = err_2;
                    return [3, 4];
                case 4:
                    expect(caughtError.message).toMatch(/Expected .* shape .*, but got shape/);
                    return [2];
            }
        });
    }); });
    it('Offline recognize succeeds with single Float32Array', function () { return __awaiter(_this, void 0, void 0, function () {
        var spectrogram, recognizer, output;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    spectrogram = new Float32Array(fakeNumFrames * fakeColumnTruncateLength * 1);
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, recognizer.recognize(spectrogram)];
                case 1:
                    output = _a.sent();
                    expect(output.scores instanceof Float32Array).toEqual(true);
                    expect(output.scores.length).toEqual(17);
                    return [2];
            }
        });
    }); });
    it('Offline recognize succeeds with batched Float32Array', function () { return __awaiter(_this, void 0, void 0, function () {
        var spectrogram, recognizer, output, i;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    spectrogram = new Float32Array(2 * fakeNumFrames * fakeColumnTruncateLength * 1);
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, recognizer.recognize(spectrogram)];
                case 1:
                    output = _a.sent();
                    expect(Array.isArray(output.scores)).toEqual(true);
                    expect(output.scores.length).toEqual(2);
                    for (i = 0; i < 2; ++i) {
                        expect(output.scores[i].length).toEqual(17);
                    }
                    return [2];
            }
        });
    }); });
    it('listen() call with invalid overlapFactor', function () { return __awaiter(_this, void 0, void 0, function () {
        var recognizer, caughtError, err_3, err_4, err_5;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4, recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2];
                        }); }); }, { overlapFactor: -1.2 })];
                case 2:
                    _a.sent();
                    return [3, 4];
                case 3:
                    err_3 = _a.sent();
                    caughtError = err_3;
                    return [3, 4];
                case 4:
                    expect(caughtError.message).toMatch(/Expected overlapFactor/);
                    _a.label = 5;
                case 5:
                    _a.trys.push([5, 7, , 8]);
                    return [4, recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2];
                        }); }); }, { overlapFactor: 1 })];
                case 6:
                    _a.sent();
                    return [3, 8];
                case 7:
                    err_4 = _a.sent();
                    caughtError = err_4;
                    return [3, 8];
                case 8:
                    expect(caughtError.message).toMatch(/Expected overlapFactor/);
                    _a.label = 9;
                case 9:
                    _a.trys.push([9, 11, , 12]);
                    return [4, recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2];
                        }); }); }, { overlapFactor: 1.2 })];
                case 10:
                    _a.sent();
                    return [3, 12];
                case 11:
                    err_5 = _a.sent();
                    caughtError = err_5;
                    return [3, 12];
                case 12:
                    expect(caughtError.message).toMatch(/Expected overlapFactor/);
                    return [2];
            }
        });
    }); });
    it('listen() call with invalid probabilityThreshold', function () { return __awaiter(_this, void 0, void 0, function () {
        var recognizer, caughtError, err_6, err_7;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4, recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2];
                        }); }); }, { probabilityThreshold: 1.2 })];
                case 2:
                    _a.sent();
                    return [3, 4];
                case 3:
                    err_6 = _a.sent();
                    caughtError = err_6;
                    return [3, 4];
                case 4:
                    expect(caughtError.message)
                        .toMatch(/Invalid probabilityThreshold value: 1\.2/);
                    _a.label = 5;
                case 5:
                    _a.trys.push([5, 7, , 8]);
                    return [4, recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2];
                        }); }); }, { probabilityThreshold: -0.1 })];
                case 6:
                    _a.sent();
                    return [3, 8];
                case 7:
                    err_7 = _a.sent();
                    caughtError = err_7;
                    return [3, 8];
                case 8:
                    expect(caughtError.message)
                        .toMatch(/Invalid probabilityThreshold value: -0\.1/);
                    return [2];
            }
        });
    }); });
    it('streaming: overlapFactor = 0', function (done) {
        setUpFakes();
        var recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
        var numCallbacksToComplete = 2;
        var numCallbacksCompleted = 0;
        var spectroDurationMillis = 1000;
        var tensorCounts = [];
        var callbackTimestamps = [];
        recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () {
            var timeBetweenCallbacks;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expect(result.scores.length).toEqual(fakeWords.length);
                        callbackTimestamps.push(tf.util.now());
                        if (callbackTimestamps.length > 1) {
                            timeBetweenCallbacks = callbackTimestamps[callbackTimestamps.length - 1] -
                                callbackTimestamps[callbackTimestamps.length - 2];
                            expect(timeBetweenCallbacks > spectroDurationMillis &&
                                timeBetweenCallbacks < 1.3 * spectroDurationMillis)
                                .toBe(true);
                        }
                        tensorCounts.push(tf.memory().numTensors);
                        if (tensorCounts.length > 1) {
                            expect(tensorCounts[tensorCounts.length - 1])
                                .toEqual(tensorCounts[tensorCounts.length - 2]);
                        }
                        expect(result.spectrogram).toBeUndefined();
                        expect(result.embedding).toBeUndefined();
                        if (!(++numCallbacksCompleted >= numCallbacksToComplete)) return [3, 2];
                        return [4, recognizer.stopListening()];
                    case 1:
                        _a.sent();
                        done();
                        _a.label = 2;
                    case 2: return [2];
                }
            });
        }); }, { overlapFactor: 0, invokeCallbackOnNoiseAndUnknown: true });
    });
    it('streaming: overlapFactor = 0, includeEmbedding', function (done) {
        setUpFakes();
        var recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
        var numCallbacksToComplete = 2;
        var numCallbacksCompleted = 0;
        var tensorCounts = [];
        var callbackTimestamps = [];
        recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expect(result.scores.length).toEqual(fakeWords.length);
                        callbackTimestamps.push(tf.util.now());
                        if (callbackTimestamps.length > 1) {
                            expect(callbackTimestamps[callbackTimestamps.length - 1] -
                                callbackTimestamps[callbackTimestamps.length - 2])
                                .toBeGreaterThanOrEqual(recognizer.params().spectrogramDurationMillis);
                        }
                        tensorCounts.push(tf.memory().numTensors);
                        expect(result.spectrogram).toBeUndefined();
                        expect(result.embedding.rank).toEqual(2);
                        expect(result.embedding.shape[0]).toEqual(1);
                        expect(result.embedding.shape[1]).toEqual(4);
                        if (!(++numCallbacksCompleted >= numCallbacksToComplete)) return [3, 2];
                        return [4, recognizer.stopListening()];
                    case 1:
                        _a.sent();
                        done();
                        _a.label = 2;
                    case 2: return [2];
                }
            });
        }); }, {
            overlapFactor: 0,
            invokeCallbackOnNoiseAndUnknown: true,
            includeEmbedding: true
        });
    });
    it('streaming: overlapFactor = 0.5, includeSpectrogram', function (done) {
        setUpFakes();
        var recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
        var numCallbacksToComplete = 2;
        var numCallbacksCompleted = 0;
        var spectroDurationMillis = 1000;
        var tensorCounts = [];
        var callbackTimestamps = [];
        recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () {
            var timeBetweenCallbacks;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        expect(result.scores.length).toEqual(fakeWords.length);
                        callbackTimestamps.push(tf.util.now());
                        if (callbackTimestamps.length > 1) {
                            timeBetweenCallbacks = callbackTimestamps[callbackTimestamps.length - 1] -
                                callbackTimestamps[callbackTimestamps.length - 2];
                            expect(timeBetweenCallbacks > 0.5 * spectroDurationMillis &&
                                timeBetweenCallbacks < 0.7 * spectroDurationMillis)
                                .toBe(true);
                        }
                        tensorCounts.push(tf.memory().numTensors);
                        if (tensorCounts.length > 1) {
                            expect(tensorCounts[tensorCounts.length - 1])
                                .toEqual(tensorCounts[tensorCounts.length - 2]);
                        }
                        expect(result.spectrogram.data.length)
                            .toBe(fakeNumFrames * fakeColumnTruncateLength);
                        expect(result.spectrogram.frameSize).toBe(fakeColumnTruncateLength);
                        if (!(++numCallbacksCompleted >= numCallbacksToComplete)) return [3, 2];
                        return [4, recognizer.stopListening()];
                    case 1:
                        _a.sent();
                        done();
                        _a.label = 2;
                    case 2: return [2];
                }
            });
        }); }, {
            overlapFactor: 0.5,
            includeSpectrogram: true,
            invokeCallbackOnNoiseAndUnknown: true
        });
    });
    it('streaming: invokeCallbackOnNoiseAndUnknown = false', function (done) {
        setUpFakes(null, true);
        var recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
        var callbackInvokeCount = 0;
        recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                callbackInvokeCount++;
                return [2];
            });
        }); }, { overlapFactor: 0.5, invokeCallbackOnNoiseAndUnknown: false });
        setTimeout(function () {
            recognizer.stopListening();
            expect(callbackInvokeCount).toEqual(0);
            done();
        }, 1000);
    });
    it('streaming: invokeCallbackOnNoiseAndUnknown = true', function (done) {
        setUpFakes(null, true);
        var recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
        var callbackInvokeCount = 0;
        recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                callbackInvokeCount++;
                return [2];
            });
        }); }, { overlapFactor: 0.5, invokeCallbackOnNoiseAndUnknown: true });
        setTimeout(function () {
            recognizer.stopListening();
            expect(callbackInvokeCount).toBeGreaterThan(0);
            done();
        }, 1000);
    });
    it('Attempt to start streaming twice leads to Error', function () { return __awaiter(_this, void 0, void 0, function () {
        var recognizer, caughtError, err_8;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2];
                        }); }); })];
                case 1:
                    _a.sent();
                    expect(recognizer.isListening()).toEqual(true);
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4, recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2];
                        }); }); })];
                case 3:
                    _a.sent();
                    return [3, 5];
                case 4:
                    err_8 = _a.sent();
                    caughtError = err_8;
                    return [3, 5];
                case 5:
                    expect(caughtError.message)
                        .toEqual('Cannot start streaming again when streaming is ongoing.');
                    expect(recognizer.isListening()).toEqual(true);
                    return [4, recognizer.stopListening()];
                case 6:
                    _a.sent();
                    expect(recognizer.isListening()).toEqual(false);
                    return [2];
            }
        });
    }); });
    it('Attempt to stop streaming twice leads to Error', function () { return __awaiter(_this, void 0, void 0, function () {
        var recognizer, caughtError, err_9;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, recognizer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2];
                        }); }); })];
                case 1:
                    _a.sent();
                    expect(recognizer.isListening()).toEqual(true);
                    return [4, recognizer.stopListening()];
                case 2:
                    _a.sent();
                    expect(recognizer.isListening()).toEqual(false);
                    _a.label = 3;
                case 3:
                    _a.trys.push([3, 5, , 6]);
                    return [4, recognizer.stopListening()];
                case 4:
                    _a.sent();
                    return [3, 6];
                case 5:
                    err_9 = _a.sent();
                    caughtError = err_9;
                    return [3, 6];
                case 6:
                    expect(caughtError.message)
                        .toEqual('Cannot stop streaming when streaming is not ongoing.');
                    expect(recognizer.isListening()).toEqual(false);
                    return [2];
            }
        });
    }); });
    it('Online recognize() call succeeds', function () { return __awaiter(_this, void 0, void 0, function () {
        var recognizer, i, output;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < 2)) return [3, 4];
                    return [4, recognizer.recognize()];
                case 2:
                    output = _a.sent();
                    expect(output.scores.length).toEqual(fakeWords.length);
                    expect(output.embedding).toBeUndefined();
                    _a.label = 3;
                case 3:
                    ++i;
                    return [3, 1];
                case 4: return [2];
            }
        });
    }); });
    it('Online recognize() call with includeEmbedding succeeds', function () { return __awaiter(_this, void 0, void 0, function () {
        var recognizer, i, output;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < 2)) return [3, 4];
                    return [4, recognizer.recognize(null, { includeEmbedding: true })];
                case 2:
                    output = _a.sent();
                    expect(output.scores.length).toEqual(fakeWords.length);
                    expect(output.embedding.rank).toEqual(2);
                    expect(output.embedding.shape[0]).toEqual(1);
                    expect(output.spectrogram).toBeUndefined();
                    _a.label = 3;
                case 3:
                    ++i;
                    return [3, 1];
                case 4: return [2];
            }
        });
    }); });
    it('Online recognize() call with includeSpectrogram succeeds', function () { return __awaiter(_this, void 0, void 0, function () {
        var recognizer, i, output;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    recognizer = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < 2)) return [3, 4];
                    return [4, recognizer.recognize(null, { includeSpectrogram: true })];
                case 2:
                    output = _a.sent();
                    expect(output.scores.length).toEqual(fakeWords.length);
                    expect(output.embedding).toBeUndefined();
                    expect(output.spectrogram.frameSize).toEqual(fakeColumnTruncateLength);
                    expect(output.spectrogram.data.length)
                        .toEqual(fakeColumnTruncateLength * fakeNumFrames);
                    _a.label = 3;
                case 3:
                    ++i;
                    return [3, 1];
                case 4: return [2];
            }
        });
    }); });
    it('collectTransferLearningExample default transerf model', function () { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer, spectrogram;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    transfer = base.createTransfer('xfer1');
                    return [4, transfer.collectExample('foo')];
                case 2:
                    spectrogram = _a.sent();
                    expect(spectrogram.frameSize).toEqual(fakeColumnTruncateLength);
                    expect(spectrogram.data.length)
                        .toEqual(fakeNumFrames * fakeColumnTruncateLength);
                    expect(transfer.wordLabels()).toEqual(['foo']);
                    expect(base.wordLabels()).toEqual(fakeWords);
                    expect(transfer.countExamples()).toEqual({ 'foo': 1 });
                    return [4, transfer.collectExample('foo')];
                case 3:
                    spectrogram = _a.sent();
                    expect(spectrogram.frameSize).toEqual(fakeColumnTruncateLength);
                    expect(spectrogram.data.length)
                        .toEqual(fakeNumFrames * fakeColumnTruncateLength);
                    expect(transfer.wordLabels()).toEqual(['foo']);
                    expect(transfer.countExamples()).toEqual({ 'foo': 2 });
                    return [4, transfer.collectExample('bar')];
                case 4:
                    spectrogram = _a.sent();
                    expect(spectrogram.frameSize).toEqual(fakeColumnTruncateLength);
                    expect(spectrogram.data.length)
                        .toEqual(fakeNumFrames * fakeColumnTruncateLength);
                    expect(transfer.wordLabels()).toEqual(['bar', 'foo']);
                    expect(transfer.countExamples()).toEqual({ 'bar': 1, 'foo': 2 });
                    return [2];
            }
        });
    }); });
    it('createTransfer with invalid name leads to Error', function () { return __awaiter(_this, void 0, void 0, function () {
        var base;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    expect(function () { return base.createTransfer(''); }).toThrowError(/non-empty string/);
                    expect(function () { return base.createTransfer(null); }).toThrowError(/non-empty string/);
                    expect(function () { return base.createTransfer(undefined); })
                        .toThrowError(/non-empty string/);
                    return [2];
            }
        });
    }); });
    it('createTransfer with duplicate name leads to Error', function () { return __awaiter(_this, void 0, void 0, function () {
        var base;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    base.createTransfer('xfer1');
                    expect(function () { return base.createTransfer('xfer1'); })
                        .toThrowError(/There is already a transfer-learning model named \'xfer1\'/);
                    base.createTransfer('xfer2');
                    return [2];
            }
        });
    }); });
    it('createTransfer before model loading leads to Error', function () { return __awaiter(_this, void 0, void 0, function () {
        var base;
        return __generator(this, function (_a) {
            setUpFakes();
            base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
            expect(function () { return base.createTransfer('xfer1'); })
                .toThrowError(/Model has not been loaded yet/);
            return [2];
        });
    }); });
    it('transfer recognizer has correct modelInputShape', function () { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    transfer = base.createTransfer('xfer1');
                    expect(transfer.modelInputShape()).toEqual(base.modelInputShape());
                    return [2];
            }
        });
    }); });
    it('transfer recognizer has correct params', function () { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    transfer = base.createTransfer('xfer1');
                    expect(transfer.params()).toEqual(base.params());
                    return [2];
            }
        });
    }); });
    it('clearTransferLearningExamples default transfer model', function () { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer, spectrogram;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    transfer = base.createTransfer('xfer1');
                    return [4, transfer.collectExample('foo')];
                case 2:
                    spectrogram = _a.sent();
                    expect(spectrogram.frameSize).toEqual(fakeColumnTruncateLength);
                    expect(spectrogram.data.length)
                        .toEqual(fakeNumFrames * fakeColumnTruncateLength);
                    expect(transfer.wordLabels()).toEqual(['foo']);
                    expect(base.wordLabels()).toEqual(fakeWords);
                    expect(transfer.countExamples()).toEqual({ 'foo': 1 });
                    transfer.clearExamples();
                    expect(transfer.wordLabels()).toEqual(null);
                    expect(function () { return transfer.countExamples(); }).toThrow();
                    return [4, transfer.collectExample('bar')];
                case 3:
                    spectrogram = _a.sent();
                    expect(spectrogram.frameSize).toEqual(fakeColumnTruncateLength);
                    expect(spectrogram.data.length)
                        .toEqual(fakeNumFrames * fakeColumnTruncateLength);
                    expect(transfer.wordLabels()).toEqual(['bar']);
                    expect(transfer.countExamples()).toEqual({ 'bar': 1 });
                    return [2];
            }
        });
    }); });
    it('Collect examples for 2 transfer models', function () { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer1, spectrogram, transfer2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    transfer1 = base.createTransfer('xfer1');
                    return [4, transfer1.collectExample('foo')];
                case 2:
                    spectrogram = _a.sent();
                    expect(spectrogram.frameSize).toEqual(fakeColumnTruncateLength);
                    expect(spectrogram.data.length)
                        .toEqual(fakeNumFrames * fakeColumnTruncateLength);
                    expect(transfer1.wordLabels()).toEqual(['foo']);
                    return [4, base.createTransfer('xfer2')];
                case 3:
                    transfer2 = _a.sent();
                    return [4, transfer2.collectExample('bar')];
                case 4:
                    spectrogram = _a.sent();
                    expect(spectrogram.frameSize).toEqual(fakeColumnTruncateLength);
                    expect(spectrogram.data.length)
                        .toEqual(fakeNumFrames * fakeColumnTruncateLength);
                    expect(transfer2.wordLabels()).toEqual(['bar']);
                    expect(transfer1.wordLabels()).toEqual(['foo']);
                    transfer1.clearExamples();
                    expect(transfer2.wordLabels()).toEqual(['bar']);
                    expect(transfer1.wordLabels()).toEqual(null);
                    expect(base.wordLabels()).toEqual(fakeWords);
                    return [2];
            }
        });
    }); });
    it('clearExamples fails if called without examples', function () { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    transfer = base.createTransfer('xfer1');
                    expect(function () { return transfer.clearExamples(); })
                        .toThrowError(/No transfer learning examples .*xfer1/);
                    return [2];
            }
        });
    }); });
    it('collectExample fails on undefined/null/empty word', function () { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer, errorCaught, err_10, err_11, err_12;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    transfer = base.createTransfer('xfer1');
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4, transfer.collectExample(undefined)];
                case 3:
                    _a.sent();
                    return [3, 5];
                case 4:
                    err_10 = _a.sent();
                    errorCaught = err_10;
                    return [3, 5];
                case 5:
                    expect(errorCaught.message).toMatch(/non-empty string/);
                    _a.label = 6;
                case 6:
                    _a.trys.push([6, 8, , 9]);
                    return [4, transfer.collectExample(null)];
                case 7:
                    _a.sent();
                    return [3, 9];
                case 8:
                    err_11 = _a.sent();
                    errorCaught = err_11;
                    return [3, 9];
                case 9:
                    expect(errorCaught.message).toMatch(/non-empty string/);
                    _a.label = 10;
                case 10:
                    _a.trys.push([10, 12, , 13]);
                    return [4, transfer.collectExample('')];
                case 11:
                    _a.sent();
                    return [3, 13];
                case 12:
                    err_12 = _a.sent();
                    errorCaught = err_12;
                    return [3, 13];
                case 13:
                    expect(errorCaught.message).toMatch(/non-empty string/);
                    return [2];
            }
        });
    }); });
    it('Concurrent collectTransferLearningExample call fails', function (done) { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer1, caughtError, err_13;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    return [4, base.createTransfer('xfer1')];
                case 2:
                    transfer1 = _a.sent();
                    transfer1.collectExample('foo').then(function () {
                        done();
                    });
                    _a.label = 3;
                case 3:
                    _a.trys.push([3, 5, , 6]);
                    return [4, transfer1.collectExample('foo')];
                case 4:
                    _a.sent();
                    return [3, 6];
                case 5:
                    err_13 = _a.sent();
                    caughtError = err_13;
                    return [3, 6];
                case 6:
                    expect(caughtError.message)
                        .toMatch(/Cannot start collection of transfer-learning example/);
                    return [2];
            }
        });
    }); });
    it('Concurrent collectExample+listen fails', function () { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer, caughtError, err_14;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    return [4, base.listen(function (result) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2];
                        }); }); })];
                case 2:
                    _a.sent();
                    expect(base.isListening()).toEqual(true);
                    transfer = base.createTransfer('xfer1');
                    _a.label = 3;
                case 3:
                    _a.trys.push([3, 5, , 6]);
                    return [4, transfer.collectExample('foo')];
                case 4:
                    _a.sent();
                    return [3, 6];
                case 5:
                    err_14 = _a.sent();
                    caughtError = err_14;
                    return [3, 6];
                case 6:
                    expect(caughtError.message)
                        .toMatch(/Cannot start collection of transfer-learning example/);
                    expect(base.isListening()).toEqual(true);
                    return [4, base.stopListening()];
                case 7:
                    _a.sent();
                    expect(base.isListening()).toEqual(false);
                    return [2];
            }
        });
    }); });
    it('trainTransferLearningModel default params', function (done) { return __awaiter(_this, void 0, void 0, function () {
        var e_1, _a, base, transfer, i, baseModel, _b, _c, layer, baseModelOldWeightValues, transferHead, numLayers, oldTransferKernel, history, baseModelNewWeightValues, newTransferKernel, spectrogram, result;
        var _this = this;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _d.sent();
                    transfer = base.createTransfer('xfer1');
                    return [4, transfer.collectExample('foo')];
                case 2:
                    _d.sent();
                    i = 0;
                    _d.label = 3;
                case 3:
                    if (!(i < 2)) return [3, 6];
                    return [4, transfer.collectExample('bar')];
                case 4:
                    _d.sent();
                    _d.label = 5;
                case 5:
                    ++i;
                    return [3, 3];
                case 6: return [4, transfer.train({ epochs: 1, optimizer: tf.train.sgd(0) })];
                case 7:
                    _d.sent();
                    baseModel = base.model;
                    try {
                        for (_b = __values(baseModel.layers), _c = _b.next(); !_c.done; _c = _b.next()) {
                            layer = _c.value;
                            expect(layer.trainable).toEqual(false);
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    baseModelOldWeightValues = [];
                    baseModel.layers.forEach(function (layer) {
                        layer.getWeights().forEach(function (w) {
                            baseModelOldWeightValues.push(w.dataSync());
                        });
                    });
                    transferHead = transfer.transferHead;
                    numLayers = transferHead.layers.length;
                    oldTransferKernel = transferHead.getLayer(null, numLayers - 1).getWeights()[0].dataSync();
                    return [4, transfer.train({ optimizer: tf.train.sgd(1) })];
                case 8:
                    history = _d.sent();
                    expect(history.history.loss.length).toEqual(20);
                    expect(history.history.acc.length).toEqual(20);
                    baseModelNewWeightValues = [];
                    baseModel.layers.forEach(function (layer) {
                        layer.getWeights().forEach(function (w) {
                            baseModelNewWeightValues.push(w.dataSync());
                        });
                    });
                    newTransferKernel = transferHead.getLayer(null, numLayers - 1).getWeights()[0].dataSync();
                    baseModelOldWeightValues.forEach(function (oldWeight, i) {
                        tf.test_util.expectArraysClose(baseModelNewWeightValues[i], oldWeight);
                    });
                    expect(tf.tensor1d(newTransferKernel)
                        .sub(tf.tensor1d(oldTransferKernel))
                        .abs()
                        .max()
                        .dataSync()[0])
                        .toBeGreaterThan(1e-3);
                    spectrogram = tf.zeros([1, fakeNumFrames, fakeColumnTruncateLength, 1]);
                    return [4, transfer.recognize(spectrogram)];
                case 9:
                    result = _d.sent();
                    expect(result.scores.length).toEqual(2);
                    expect(base.wordLabels()).toEqual(fakeWords);
                    expect(transfer.wordLabels()).toEqual(['bar', 'foo']);
                    transfer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    expect(result.scores.length).toEqual(2);
                                    return [4, transfer.stopListening()];
                                case 1:
                                    _a.sent();
                                    done();
                                    return [2];
                            }
                        });
                    }); });
                    return [2];
            }
        });
    }); });
    it('trainTransferLearningModel custom params', function (done) { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer, i, history;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    transfer = base.createTransfer('xfer1');
                    return [4, transfer.collectExample('foo')];
                case 2:
                    _a.sent();
                    i = 0;
                    _a.label = 3;
                case 3:
                    if (!(i < 2)) return [3, 6];
                    return [4, transfer.collectExample('bar')];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    ++i;
                    return [3, 3];
                case 6: return [4, transfer.train({ epochs: 10, batchSize: 2 })];
                case 7:
                    history = _a.sent();
                    expect(history.history.loss.length).toEqual(10);
                    expect(history.history.acc.length).toEqual(10);
                    expect(base.wordLabels()).toEqual(fakeWords);
                    expect(transfer.wordLabels()).toEqual(['bar', 'foo']);
                    transfer.listen(function (result) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    expect(result.scores.length).toEqual(2);
                                    return [4, transfer.stopListening()];
                                case 1:
                                    _a.sent();
                                    done();
                                    return [2];
                            }
                        });
                    }); });
                    return [2];
            }
        });
    }); });
    it('trainTransferLearningModel custom params and callback', function () { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer, i, callbackEpochs, history;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    transfer = base.createTransfer('xfer1');
                    return [4, transfer.collectExample('foo')];
                case 2:
                    _a.sent();
                    i = 0;
                    _a.label = 3;
                case 3:
                    if (!(i < 2)) return [3, 6];
                    return [4, transfer.collectExample('bar')];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    ++i;
                    return [3, 3];
                case 6:
                    callbackEpochs = [];
                    return [4, transfer.train({
                            epochs: 5,
                            callback: {
                                onEpochEnd: function (epoch, logs) { return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        callbackEpochs.push(epoch);
                                        return [2];
                                    });
                                }); }
                            }
                        })];
                case 7:
                    history = _a.sent();
                    expect(history.history.loss.length).toEqual(5);
                    expect(history.history.acc.length).toEqual(5);
                    expect(callbackEpochs).toEqual([0, 1, 2, 3, 4]);
                    return [2];
            }
        });
    }); });
    it('trainTransferLearningModel fails without any examples', function () { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer, errorCaught, err_15;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    transfer = base.createTransfer('xfer1');
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4, transfer.train()];
                case 3:
                    _a.sent();
                    return [3, 5];
                case 4:
                    err_15 = _a.sent();
                    errorCaught = err_15;
                    return [3, 5];
                case 5:
                    expect(errorCaught.message)
                        .toMatch(/no transfer learning example has been collected/);
                    return [2];
            }
        });
    }); });
    it('trainTransferLearningModel fails with only 1 word', function () { return __awaiter(_this, void 0, void 0, function () {
        var base, transfer, errorCaught, err_16;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setUpFakes();
                    base = new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
                    return [4, base.ensureModelLoaded()];
                case 1:
                    _a.sent();
                    transfer = base.createTransfer('xfer1');
                    return [4, transfer.collectExample('foo')];
                case 2:
                    _a.sent();
                    return [4, transfer.collectExample('foo')];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4:
                    _a.trys.push([4, 6, , 7]);
                    return [4, transfer.train()];
                case 5:
                    _a.sent();
                    return [3, 7];
                case 6:
                    err_16 = _a.sent();
                    errorCaught = err_16;
                    return [3, 7];
                case 7:
                    expect(errorCaught.message).toMatch(/.*foo.*Requires at least 2/);
                    return [2];
            }
        });
    }); });
    it('Invalid vocabulary name leads to Error', function () {
        expect(function () { return index_1.create('BROWSER_FFT', 'nonsensical_vocab'); })
            .toThrowError(/Invalid vocabulary name.*\'nonsensical_vocab\'/);
    });
});
//# sourceMappingURL=browser_fft_recognizer_test.js.map