/**
 * @license
 * Copyright 2018 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import{util,dispose,loadModel,model,tidy,zeros,Tensor,tensor4d,unstack,concat,oneHot,tensor1d,sequential,layers,tensor,moments}from"@tensorflow/tfjs";var extendStatics=function(e,t){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(e,t)};function __extends(e,t){function r(){this.constructor=e}extendStatics(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}function __awaiter(e,t,r,n){return new(r||(r=Promise))(function(a,s){function o(e){try{l(n.next(e))}catch(e){s(e)}}function i(e){try{l(n.throw(e))}catch(e){s(e)}}function l(e){e.done?a(e.value):new r(function(t){t(e.value)}).then(o,i)}l((n=n.apply(e,t||[])).next())})}function __generator(e,t){var r,n,a,s,o={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return s={next:i(0),throw:i(1),return:i(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s;function i(s){return function(i){return function(s){if(r)throw new TypeError("Generator is already executing.");for(;o;)try{if(r=1,n&&(a=2&s[0]?n.return:s[0]?n.throw||((a=n.return)&&a.call(n),0):n.next)&&!(a=a.call(n,s[1])).done)return a;switch(n=0,a&&(s=[2&s[0],a.value]),s[0]){case 0:case 1:a=s;break;case 4:return o.label++,{value:s[1],done:!1};case 5:o.label++,n=s[1],s=[0];continue;case 7:s=o.ops.pop(),o.trys.pop();continue;default:if(!(a=(a=o.trys).length>0&&a[a.length-1])&&(6===s[0]||2===s[0])){o=0;continue}if(3===s[0]&&(!a||s[1]>a[0]&&s[1]<a[3])){o.label=s[1];break}if(6===s[0]&&o.label<a[1]){o.label=a[1],a=s;break}if(a&&o.label<a[2]){o.label=a[2],o.ops.push(s);break}a[2]&&o.ops.pop(),o.trys.pop();continue}s=t.call(e,o)}catch(e){s=[6,e],n=0}finally{r=a=0}if(5&s[0])throw s[1];return{value:s[0]?s[1]:void 0,done:!0}}([s,i])}}}function __values(e){var t="function"==typeof Symbol&&e[Symbol.iterator],r=0;return t?t.call(e):{next:function(){return e&&r>=e.length&&(e=void 0),{value:e&&e[r++],done:!e}}}}function __read(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,a,s=r.call(e),o=[];try{for(;(void 0===t||t-- >0)&&!(n=s.next()).done;)o.push(n.value)}catch(e){a={error:e}}finally{try{n&&!n.done&&(r=s.return)&&r.call(s)}finally{if(a)throw a.error}}return o}function __spread(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(__read(arguments[t]));return e}function loadMetadataJson(e){return __awaiter(this,void 0,void 0,function(){var t,r,n,a;return __generator(this,function(s){switch(s.label){case 0:return t="http://",r="https://",n="file://",0!==e.indexOf(t)&&0!==e.indexOf(r)?[3,3]:[4,fetch(e)];case 1:return[4,s.sent().json()];case 2:return[2,s.sent()];case 3:if(0===e.indexOf(n))return a=require("fs"),[2,JSON.parse(a.readFileSync(e.slice(n.length),{encoding:"utf-8"}))];throw new Error("Unsupported URL scheme in metadata URL: "+e+". Supported schemes are: http://, https://, and (node.js-only) file://");case 4:return[2]}})})}function normalize(e){return tidy(function(){var t=moments(e),r=t.mean,n=t.variance;return e.sub(r).div(n.sqrt())})}function getAudioContextConstructor(){return window.AudioContext||window.webkitAudioContext}function getAudioMediaStream(){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(e){switch(e.label){case 0:return[4,navigator.mediaDevices.getUserMedia({audio:!0,video:!1})];case 1:return[2,e.sent()]}})})}var BrowserFftFeatureExtractor=function(){function e(e){if(null==e)throw new Error("Required configuration object is missing for BrowserFftFeatureExtractor constructor");if(null==e.spectrogramCallback)throw new Error("spectrogramCallback cannot be null or undefined");if(!(e.numFramesPerSpectrogram>0))throw new Error("Invalid value in numFramesPerSpectrogram: "+e.numFramesPerSpectrogram);if(e.suppressionTimeMillis<0)throw new Error("Expected suppressionTimeMillis to be >= 0, but got "+e.suppressionTimeMillis);if(this.suppressionTimeMillis=e.suppressionTimeMillis,this.spectrogramCallback=e.spectrogramCallback,this.numFrames=e.numFramesPerSpectrogram,this.sampleRateHz=e.sampleRateHz||44100,this.fftSize=e.fftSize||1024,this.frameDurationMillis=this.fftSize/this.sampleRateHz*1e3,this.columnTruncateLength=e.columnTruncateLength||this.fftSize,this.overlapFactor=e.overlapFactor,util.assert(this.overlapFactor>=0&&this.overlapFactor<1,"Expected overlapFactor to be >= 0 and < 1, but got "+this.overlapFactor),this.columnTruncateLength>this.fftSize)throw new Error("columnTruncateLength "+this.columnTruncateLength+" exceeds fftSize ("+this.fftSize+").");this.audioContextConstructor=getAudioContextConstructor()}return e.prototype.start=function(){return __awaiter(this,void 0,void 0,function(){var e,t,r;return __generator(this,function(n){switch(n.label){case 0:if(null!=this.frameIntervalTask)throw new Error("Cannot start already-started BrowserFftFeatureExtractor");return e=this,[4,getAudioMediaStream()];case 1:return e.stream=n.sent(),this.audioContext=new this.audioContextConstructor,this.audioContext.sampleRate!==this.sampleRateHz&&console.warn("Mismatch in sampling rate: Expected: "+this.sampleRateHz+"; Actual: "+this.audioContext.sampleRate),t=this.audioContext.createMediaStreamSource(this.stream),this.analyser=this.audioContext.createAnalyser(),this.analyser.fftSize=2*this.fftSize,this.analyser.smoothingTimeConstant=0,t.connect(this.analyser),this.freqDataQueue=[],this.freqData=new Float32Array(this.fftSize),r=Math.max(1,Math.round(this.numFrames*(1-this.overlapFactor))),this.tracker=new Tracker(r,Math.round(this.suppressionTimeMillis/this.frameDurationMillis)),this.frameIntervalTask=setInterval(this.onAudioFrame.bind(this),this.fftSize/this.sampleRateHz*1e3),[2]}})})},e.prototype.onAudioFrame=function(){return __awaiter(this,void 0,void 0,function(){var e,t;return __generator(this,function(r){switch(r.label){case 0:return this.analyser.getFloatFrequencyData(this.freqData),this.freqData[0]===-1/0?[2]:(this.freqDataQueue.push(this.freqData.slice(0,this.columnTruncateLength)),this.freqDataQueue.length>this.numFrames&&this.freqDataQueue.shift(),this.tracker.tick()?(e=flattenQueue(this.freqDataQueue),t=getInputTensorFromFrequencyData(e,[1,this.numFrames,this.columnTruncateLength,1]),[4,this.spectrogramCallback(t)]):[3,2]);case 1:r.sent()&&this.tracker.suppress(),t.dispose(),r.label=2;case 2:return[2]}})})},e.prototype.stop=function(){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(e){if(null==this.frameIntervalTask)throw new Error("Cannot stop because there is no ongoing streaming activity.");return clearInterval(this.frameIntervalTask),this.frameIntervalTask=null,this.analyser.disconnect(),this.audioContext.close(),null!=this.stream&&this.stream.getTracks().length>0&&this.stream.getTracks()[0].stop(),[2]})})},e.prototype.setConfig=function(e){throw new Error("setConfig() is not implemented for BrowserFftFeatureExtractor.")},e.prototype.getFeatures=function(){throw new Error("getFeatures() is not implemented for BrowserFftFeatureExtractor. Use the spectrogramCallback field of the constructor config instead.")},e}();function flattenQueue(e){var t=e[0].length,r=new Float32Array(e.length*t);return e.forEach(function(e,n){return r.set(e,n*t)}),r}function getInputTensorFromFrequencyData(e,t){var r=new Float32Array(util.sizeFromShape(t));return r.set(e,r.length-e.length),tensor(r,t)}var Tracker=function(){function e(e,t){this.period=e,this.suppressionTime=null==t?0:t,this.counter=0,util.assert(this.period>0,"Expected period to be positive, but got "+this.period)}return e.prototype.tick=function(){return this.counter++,this.counter%this.period==0&&(null==this.suppressionOnset||this.counter-this.suppressionOnset>this.suppressionTime)},e.prototype.suppress=function(){this.suppressionOnset=this.counter},e}(),version="0.2.2",BACKGROUND_NOISE_TAG="_background_noise_",UNKNOWN_TAG="_unknown_",streaming=!1;function getMajorAndMinorVersion(e){return e.split(".").slice(0,2).join(".")}var BrowserFftSpeechCommandRecognizer=function(){function e(t,r,n){this.MODEL_URL_PREFIX="https://storage.googleapis.com/tfjs-models/tfjs/speech-commands/v"+getMajorAndMinorVersion(version)+"/browser_fft",this.SAMPLE_RATE_HZ=44100,this.FFT_SIZE=1024,this.DEFAULT_SUPPRESSION_TIME_MILLIS=0,this.transferRecognizers={},util.assert(null==r&&null==n||null!=r&&null!=n,"modelURL and metadataURL must be both provided or both not provided."),null==r?(null==t?t=e.DEFAULT_VOCABULARY_NAME:util.assert(-1!==e.VALID_VOCABULARY_NAMES.indexOf(t),"Invalid vocabulary name: '"+t+"'"),this.vocabulary=t,this.modelURL=this.MODEL_URL_PREFIX+"/"+this.vocabulary+"/model.json",this.metadataURL=this.MODEL_URL_PREFIX+"/"+this.vocabulary+"/metadata.json"):(util.assert(null==t,"vocabulary name must be null or undefined when modelURL is provided"),this.modelURL=r,this.metadataURL=n),this.parameters={sampleRateHz:this.SAMPLE_RATE_HZ,fftSize:this.FFT_SIZE}}return e.prototype.listen=function(e,t){return __awaiter(this,void 0,void 0,function(){var r,n,a,s,o,i=this;return __generator(this,function(l){switch(l.label){case 0:if(streaming)throw new Error("Cannot start streaming again when streaming is ongoing.");return[4,this.ensureModelLoaded()];case 1:if(l.sent(),null==t&&(t={}),r=null==t.probabilityThreshold?0:t.probabilityThreshold,t.includeEmbedding&&(r=0),util.assert(r>=0&&r<=1,"Invalid probabilityThreshold value: "+r),n=null!=t.invokeCallbackOnNoiseAndUnknown&&t.invokeCallbackOnNoiseAndUnknown,t.includeEmbedding&&(n=!0),t.suppressionTimeMillis<0)throw new Error("suppressionTimeMillis is expected to be >= 0, but got "+t.suppressionTimeMillis);return a=null==t.overlapFactor?.5:t.overlapFactor,util.assert(a>=0&&a<1,"Expected overlapFactor to be >= 0 and < 1, but got "+a),s=function(a){return __awaiter(i,void 0,void 0,function(){var s,o,i,l,u,c,h,p,d,f,m;return __generator(this,function(g){switch(g.label){case 0:return o=normalize(a),t.includeEmbedding?[4,this.ensureModelWithEmbeddingOutputCreated()]:[3,2];case 1:return g.sent(),s=__read(this.modelWithEmbeddingOutput.predict(o),2),i=s[0],l=s[1],[3,3];case 2:i=this.model.predict(o),g.label=3;case 3:return[4,i.data()];case 4:return u=g.sent(),[4,(c=i.argMax(-1)).data()];case 5:return h=g.sent()[0],p=Math.max.apply(Math,__spread(u)),dispose([i,c,o]),p<r?[2,!1]:[3,6];case 6:return d=void 0,t.includeSpectrogram?(f={},[4,a.data()]):[3,8];case 7:f.data=g.sent(),f.frameSize=this.nonBatchInputShape[1],d=f,g.label=8;case 8:return m=!0,n||this.words[h]!==BACKGROUND_NOISE_TAG&&this.words[h]!==UNKNOWN_TAG||(m=!1),m&&e({scores:u,spectrogram:d,embedding:l}),[2,m]}})})},o=null==t.suppressionTimeMillis?this.DEFAULT_SUPPRESSION_TIME_MILLIS:t.suppressionTimeMillis,this.audioDataExtractor=new BrowserFftFeatureExtractor({sampleRateHz:this.parameters.sampleRateHz,numFramesPerSpectrogram:this.nonBatchInputShape[0],columnTruncateLength:this.nonBatchInputShape[1],suppressionTimeMillis:o,spectrogramCallback:s,overlapFactor:a}),[4,this.audioDataExtractor.start()];case 2:return l.sent(),streaming=!0,[2]}})})},e.prototype.ensureModelLoaded=function(){return __awaiter(this,void 0,void 0,function(){var e,t,r,n,a=this;return __generator(this,function(s){switch(s.label){case 0:return null!=this.model?[2]:[4,this.ensureMetadataLoaded()];case 1:return s.sent(),[4,loadModel(this.modelURL)];case 2:if(1!==(e=s.sent()).inputs.length)throw new Error("Expected model to have 1 input, but got a model with "+e.inputs.length+" inputs");if(4!==e.inputs[0].shape.length)throw new Error("Expected model to have an input shape of rank 4, but got an input shape of rank "+e.inputs[0].shape.length);if(1!==e.inputs[0].shape[3])throw new Error("Expected model to have an input shape with 1 as the last dimension, but got input shape"+JSON.stringify(e.inputs[0].shape[3])+"}");if(2!==(t=e.outputShape).length)throw new Error("Expected loaded model to have an output shape of rank 2,but received shape "+JSON.stringify(t));if(t[1]!==this.words.length)throw new Error("Mismatch between the last dimension of model's output shape ("+t[1]+") and number of words ("+this.words.length+").");return this.model=e,this.freezeModel(),this.nonBatchInputShape=e.inputs[0].shape.slice(1),this.elementsPerExample=1,e.inputs[0].shape.slice(1).forEach(function(e){return a.elementsPerExample*=e}),this.warmUpModel(),r=this.parameters.fftSize/this.parameters.sampleRateHz*1e3,n=e.inputs[0].shape[1],this.parameters.spectrogramDurationMillis=n*r,[2]}})})},e.prototype.ensureModelWithEmbeddingOutputCreated=function(){return __awaiter(this,void 0,void 0,function(){var e,t;return __generator(this,function(r){switch(r.label){case 0:return null!=this.modelWithEmbeddingOutput?[2]:[4,this.ensureModelLoaded()];case 1:for(r.sent(),t=this.model.layers.length-2;t>=0;--t)if("Dense"===this.model.layers[t].getClassName()){e=this.model.layers[t];break}if(null==e)throw new Error("Failed to find second last dense layer in the original model.");return this.modelWithEmbeddingOutput=model({inputs:this.model.inputs,outputs:[this.model.outputs[0],e.output]}),[2]}})})},e.prototype.warmUpModel=function(){var e=this;tidy(function(){for(var t=zeros([1].concat(e.nonBatchInputShape)),r=0;r<3;++r)e.model.predict(t)})},e.prototype.ensureMetadataLoaded=function(){return __awaiter(this,void 0,void 0,function(){var e;return __generator(this,function(t){switch(t.label){case 0:return null!=this.words?[2]:[4,loadMetadataJson(this.metadataURL)];case 1:return e=t.sent(),this.words=e.words,[2]}})})},e.prototype.stopListening=function(){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(e){switch(e.label){case 0:if(!streaming)throw new Error("Cannot stop streaming when streaming is not ongoing.");return[4,this.audioDataExtractor.stop()];case 1:return e.sent(),streaming=!1,[2]}})})},e.prototype.isListening=function(){return streaming},e.prototype.wordLabels=function(){return this.words},e.prototype.params=function(){return this.parameters},e.prototype.modelInputShape=function(){if(null==this.model)throw new Error("Model has not been loaded yet. Load model by calling ensureModelLoaded(), recognize(), or listen().");return this.model.inputs[0].shape},e.prototype.recognize=function(e,t){return __awaiter(this,void 0,void 0,function(){var r,n,a,s,o,i,l,u,c,h,p,d,f;return __generator(this,function(m){switch(m.label){case 0:return null==t&&(t={}),[4,this.ensureModelLoaded()];case 1:return m.sent(),null!=e?[3,3]:[4,this.recognizeOnline()];case 2:r=m.sent(),e=r.data,m.label=3;case 3:if(e instanceof Tensor)this.checkInputTensorShape(e),a=e,n=e.shape[0];else{if((e=e).length%this.elementsPerExample)throw new Error("The length of the input Float32Array "+e.length+" is not divisible by the number of tensor elements per per example expected by the model "+this.elementsPerExample+".");n=e.length/this.elementsPerExample,a=tensor4d(e,[n].concat(this.nonBatchInputShape))}return o={scores:null},t.includeEmbedding?[4,this.ensureModelWithEmbeddingOutputCreated()]:[3,5];case 4:return m.sent(),i=this.modelWithEmbeddingOutput.predict(a),s=i[0],o.embedding=i[1],[3,6];case 5:s=this.model.predict(a),m.label=6;case 6:return 1!==n?[3,8]:(l=o,[4,s.data()]);case 7:return l.scores=m.sent(),[3,10];case 8:return u=unstack(s),c=u.map(function(e){return e.data()}),h=o,[4,Promise.all(c)];case 9:h.scores=m.sent(),dispose(u),m.label=10;case 10:return t.includeSpectrogram?(p=o,d={},e instanceof Tensor?[4,e.data()]:[3,12]):[3,14];case 11:return f=m.sent(),[3,13];case 12:f=e,m.label=13;case 13:p.spectrogram=(d.data=f,d.frameSize=this.nonBatchInputShape[1],d),m.label=14;case 14:return[2,o]}})})},e.prototype.recognizeOnline=function(){return __awaiter(this,void 0,void 0,function(){var e=this;return __generator(this,function(t){return[2,new Promise(function(t,r){e.audioDataExtractor=new BrowserFftFeatureExtractor({sampleRateHz:e.parameters.sampleRateHz,numFramesPerSpectrogram:e.nonBatchInputShape[0],columnTruncateLength:e.nonBatchInputShape[1],suppressionTimeMillis:0,spectrogramCallback:function(r){return __awaiter(e,void 0,void 0,function(){var e,n,a;return __generator(this,function(s){switch(s.label){case 0:return e=normalize(r),[4,this.audioDataExtractor.stop()];case 1:return s.sent(),n=t,a={},[4,e.data()];case 2:return n.apply(void 0,[(a.data=s.sent(),a.frameSize=this.nonBatchInputShape[1],a)]),e.dispose(),[2,!1]}})})},overlapFactor:0}),e.audioDataExtractor.start()})]})})},e.prototype.createTransfer=function(e){if(null==this.model)throw new Error("Model has not been loaded yet. Load model by calling ensureModelLoaded(), recognizer(), or listen().");util.assert(null!=e&&"string"==typeof e&&e.length>1,"Expected the name for a transfer-learning recognized to be a non-empty string, but got "+JSON.stringify(e)),util.assert(null==this.transferRecognizers[e],"There is already a transfer-learning model named '"+e+"'");var t=new TransferBrowserFftSpeechCommandRecognizer(e,this.parameters,this.model);return this.transferRecognizers[e]=t,t},e.prototype.freezeModel=function(){var e,t;try{for(var r=__values(this.model.layers),n=r.next();!n.done;n=r.next()){n.value.trainable=!1}}catch(t){e={error:t}}finally{try{n&&!n.done&&(t=r.return)&&t.call(r)}finally{if(e)throw e.error}}},e.prototype.checkInputTensorShape=function(e){var t=this.model.inputs[0].shape.length;if(e.shape.length!==t)throw new Error("Expected input Tensor to have rank "+t+", but got rank "+e.shape.length+" that differs ");var r=e.shape.slice(1),n=this.model.inputs[0].shape.slice(1);if(!util.arraysEqual(r,n))throw new Error("Expected input to have shape [null,"+n+"], but got shape [null,"+r+"]")},e.VALID_VOCABULARY_NAMES=["18w","directional4w"],e.DEFAULT_VOCABULARY_NAME="18w",e}(),TransferBrowserFftSpeechCommandRecognizer=function(e){function t(t,r,n){var a=e.call(this)||this;return a.name=t,a.parameters=r,a.baseModel=n,util.assert(null!=t&&"string"==typeof t&&t.length>0,"The name of a transfer model must be a non-empty string, but got "+JSON.stringify(t)),a.nonBatchInputShape=a.baseModel.inputs[0].shape.slice(1),a.words=[],a}return __extends(t,e),t.prototype.collectExample=function(e){return __awaiter(this,void 0,void 0,function(){var t=this;return __generator(this,function(r){return util.assert(!streaming,"Cannot start collection of transfer-learning example because a streaming recognition or transfer-learning example collection is ongoing"),util.assert(null!=e&&"string"==typeof e&&e.length>0,"Must provide a non-empty string when collecting transfer-learning example"),streaming=!0,[2,new Promise(function(r){t.audioDataExtractor=new BrowserFftFeatureExtractor({sampleRateHz:t.parameters.sampleRateHz,numFramesPerSpectrogram:t.nonBatchInputShape[0],columnTruncateLength:t.nonBatchInputShape[1],suppressionTimeMillis:0,spectrogramCallback:function(n){return __awaiter(t,void 0,void 0,function(){var t,a,s;return __generator(this,function(o){switch(o.label){case 0:return null==this.transferExamples&&(this.transferExamples={}),null==this.transferExamples[e]&&(this.transferExamples[e]=[]),t=normalize(n),this.transferExamples[e].push(t.clone()),t.dispose(),[4,this.audioDataExtractor.stop()];case 1:return o.sent(),streaming=!1,this.collateTransferWords(),a=r,s={},[4,n.data()];case 2:return a.apply(void 0,[(s.data=o.sent(),s.frameSize=this.nonBatchInputShape[1],s)]),[2,!1]}})})},overlapFactor:0}),t.audioDataExtractor.start()})]})})},t.prototype.clearExamples=function(){util.assert(null!=this.words&&this.words.length>0&&null!=this.transferExamples,"No transfer learning examples exist for model name "+this.name),dispose(this.transferExamples),this.transferExamples=null,this.words=null},t.prototype.countExamples=function(){if(null==this.transferExamples)throw new Error("No examples have been collected for transfer-learning model named '"+this.name+"' yet.");var e={};for(var t in this.transferExamples)e[t]=this.transferExamples[t].length;return e},t.prototype.collateTransferWords=function(){this.words=Object.keys(this.transferExamples).sort()},t.prototype.collectTransferDataAsTensors=function(e){var t=this;return util.assert(null!=this.words&&this.words.length>0,"No word example is available for tranfer-learning model of name "+e),tidy(function(){var e=[],r=[];return t.words.forEach(function(n,a){t.transferExamples[n].forEach(function(t){e.push(t),r.push(a)})}),{xs:concat(e,0),ys:oneHot(tensor1d(r,"int32"),Object.keys(t.words).length)}})},t.prototype.train=function(e){return __awaiter(this,void 0,void 0,function(){var t,r,n,a,s,o,i;return __generator(this,function(l){switch(l.label){case 0:util.assert(null!=this.words&&this.words.length>0,"Cannot train transfer-learning model '"+this.name+"' because no transfer learning example has been collected."),util.assert(this.words.length>1,"Cannot train transfer-learning model '"+this.name+"' because only 1 word label ('"+JSON.stringify(this.words)+"') has been collected for transfer learning. Requires at least 2."),null==e&&(e={}),null==this.model&&this.createTransferModelFromBaseModel(),t=e.optimizer||"sgd",this.model.compile({loss:"categoricalCrossentropy",optimizer:t,metrics:["acc"]}),r=this.collectTransferDataAsTensors(),n=r.xs,a=r.ys,s=null==e.epochs?20:e.epochs,o=null==e.validationSplit?0:e.validationSplit,l.label=1;case 1:return l.trys.push([1,3,,4]),[4,this.model.fit(n,a,{epochs:s,validationSplit:o,batchSize:e.batchSize,callbacks:null==e.callback?null:[e.callback]})];case 2:return i=l.sent(),dispose([n,a]),[2,i];case 3:return l.sent(),dispose([n,a]),this.model=null,[2,null];case 4:return[2]}})})},t.prototype.createTransferModelFromBaseModel=function(){util.assert(null!=this.words,"No word example is available for tranfer-learning model of name "+this.name);for(var e=this.baseModel.layers,t=e.length-2;t>=0&&"dense"!==e[t].getClassName().toLowerCase();)t--;if(t<0)throw new Error("Cannot find a hidden dense layer in the base model.");var r=e[t].output;this.transferHead=sequential(),this.transferHead.add(layers.dense({units:this.words.length,activation:"softmax",inputShape:r.shape.slice(1)}));var n=this.transferHead.apply(r);this.model=model({inputs:this.baseModel.inputs,outputs:n})},t.prototype.modelInputShape=function(){return this.baseModel.inputs[0].shape},t.prototype.createTransfer=function(e){throw new Error("Creating transfer-learned recognizer from a transfer-learned recognizer is not supported.")},t}(BrowserFftSpeechCommandRecognizer);function create(e,t,r,n){if(util.assert(null==r&&null==n||null!=r&&null!=n,"customModelURL and customMetadataURL must be both provided or both not provided."),null!=r&&util.assert(null==t,"vocabulary name must be null or undefined when modelURL is provided"),"BROWSER_FFT"===e)return new BrowserFftSpeechCommandRecognizer(t,r,n);throw"SOFT_FFT"===e?new Error("SOFT_FFT SpeechCommandRecognizer has not been implemented yet."):new Error("Invalid fftType: '"+e+"'")}export{create,BACKGROUND_NOISE_TAG,UNKNOWN_TAG,version};
//# sourceMappingURL=speech-commands.esm.js.map
